
#import "XLsn0wSlideSelector.h"

#define XLsn0wSlideSelector_WIDTH ([UIScreen mainScreen].bounds.size.width)

@interface XLsn0wSlideSelector () <UIScrollViewDelegate>

@property (nonatomic, assign) NSInteger count;
@property (nonatomic, strong) UIButton *selectButton;

@end

@implementation XLsn0wSlideSelector

- (instancetype)initWithFrame:(CGRect)frame {
    if ([super initWithFrame:frame]) {
        self.backgroundColor = [UIColor whiteColor];
        [self drawXLsn0wSlideSelectorUI];
    }
    return self;
}

- (void)drawXLsn0wSlideSelectorUI {
    _count = 8;
    
    UIScrollView *bottomScrollView = [[UIScrollView alloc]initWithFrame:CGRectMake(0, 0, XLsn0wSlideSelector_WIDTH, XLsn0wSlideSelector_WIDTH/2)];
    bottomScrollView.contentSize = CGSizeMake(XLsn0wSlideSelector_WIDTH/3 * (_count + 2), 100);
    bottomScrollView.showsVerticalScrollIndicator = NO;
    bottomScrollView.showsHorizontalScrollIndicator = NO;
    bottomScrollView.delegate = self;
    bottomScrollView.tag = 10086;
    [self addSubview:bottomScrollView];
    
    for (int i = 0; i < _count + 2; i ++) {
        _selectButton = [[UIButton alloc]init];
        _selectButton.tag = 10010+i;
        
        float offsizeX = fabs(XLsn0wSlideSelector_WIDTH/6 * (2 * i + 1)- XLsn0wSlideSelector_WIDTH/2 - bottomScrollView.contentOffset.x);
        double offsizeY = sqrt(fabs(XLsn0wSlideSelector_WIDTH * XLsn0wSlideSelector_WIDTH / 4 - offsizeX*offsizeX));
        
        _selectButton.center = CGPointMake(XLsn0wSlideSelector_WIDTH/6 * (2 * i + 1),XLsn0wSlideSelector_WIDTH/2 - offsizeY + XLsn0wSlideSelector_WIDTH/4);
        _selectButton.bounds = CGRectMake(0, 0,  (XLsn0wSlideSelector_WIDTH/2-offsizeX)/(XLsn0wSlideSelector_WIDTH/2)*40+20, (XLsn0wSlideSelector_WIDTH/2-offsizeX)/(XLsn0wSlideSelector_WIDTH/2)*40+20);
        
        NSString *nullString = @"";
       
        self.selectArray = @[nullString, @"2", @"4", @"6", @"8", @"10", @"12", @"14", @"16", nullString];
        //前后加一个空字符串@""
        
        [_selectButton setTitle:[self.selectArray objectAtIndex:i] forState:(UIControlStateNormal)];
        [_selectButton setTitleColor:[UIColor whiteColor] forState:(UIControlStateNormal)];
        [_selectButton setBackgroundColor:[UIColor blueColor]];
        _selectButton.layer.masksToBounds = YES;
        _selectButton.layer.cornerRadius = _selectButton.bounds.size.width/2;
        _selectButton.titleLabel.font = [UIFont boldSystemFontOfSize:20];
        
        
        [_selectButton addTarget:self action:@selector(btnClick:) forControlEvents:UIControlEventTouchUpInside];
        [bottomScrollView addSubview:_selectButton];
        
        if (i == 0 || i == self.selectArray.count-1) {
            _selectButton.enabled = NO;
            [_selectButton setBackgroundColor:[UIColor clearColor]];
        }
    }
}

- (void)btnClick:(UIButton *)btn {
    UIScrollView * scrollView = (UIScrollView *)[self viewWithTag:10086];
    [scrollView setContentOffset:CGPointMake(XLsn0wSlideSelector_WIDTH/3 * (btn.tag-10010-1), 0) animated:YES];
   
}

#pragma mark - UIScrollViewDelegate

- (void)scrollViewDidScroll:(UIScrollView *)scrollView {
    int location = 0;
    
    location = scrollView.contentOffset.x/(XLsn0wSlideSelector_WIDTH/3);
    
    for (int i = 0; i < _count + 2; i ++){
        UIButton * Btn = (UIButton *)[self viewWithTag:10010+i];
        
        float offsizeX = fabs(Btn.center.x- XLsn0wSlideSelector_WIDTH/2 - scrollView.contentOffset.x);
        double offsizeY = sqrt(fabs(XLsn0wSlideSelector_WIDTH * XLsn0wSlideSelector_WIDTH / 4 - offsizeX*offsizeX));
        
        Btn.center = CGPointMake(Btn.center.x,XLsn0wSlideSelector_WIDTH/2- offsizeY + XLsn0wSlideSelector_WIDTH/4);
        Btn.bounds = CGRectMake(0, 0,  (XLsn0wSlideSelector_WIDTH/2-offsizeX)/(XLsn0wSlideSelector_WIDTH/2)*40+20, (XLsn0wSlideSelector_WIDTH/2-offsizeX)/(XLsn0wSlideSelector_WIDTH/2)*40+20);
        Btn.layer.masksToBounds = YES;
        Btn.layer.cornerRadius = Btn.bounds.size.width/2;
    }

    [self.xlsn0wDelegate slideSelector:self selectedIndex:location];
}

- (void)scrollViewDidEndDecelerating:(UIScrollView *)scrollView {
    int location = 0;
    
    CGFloat yy = scrollView.contentOffset.x/(XLsn0wSlideSelector_WIDTH/3);
    
    int xx  = yy*10;
    if (xx%10 >= _count)
    {
        location = xx/10 +1;
    }else
    {
        location = xx/10;
    }
    
    [scrollView setContentOffset:CGPointMake(XLsn0wSlideSelector_WIDTH/3 * location, 0) animated:YES];

    [self.xlsn0wDelegate slideSelector:self selectedIndex:location];
}

- (void)scrollViewDidEndDragging:(UIScrollView *)scrollView willDecelerate:(BOOL)decelerate {
    int location = 0;
    
    CGFloat yy = scrollView.contentOffset.x/(XLsn0wSlideSelector_WIDTH/3);
    
    int xx  = yy*10;
    if (xx%10 >= _count)
    {
        location = xx/10 +1;
    }else
    {
        location = xx/10;
    }
    
    [scrollView setContentOffset:CGPointMake(XLsn0wSlideSelector_WIDTH/3 * location, 0) animated:YES];
    

    [self.xlsn0wDelegate slideSelector:self selectedIndex:location];
}

@end
